$conf[0] = "ROW2 PB0 PD1 ROW1";
$conf[1] = "COL4 PB7 PA1 COL8";
$conf[2] = "COL3 PB6 PA0 ROW3";
$conf[3] = "COL2 PB5 PD2 ROW4";
$conf[4] = "ROW5 PB4 PD3 COL7";
$conf[5] = "ROW6 PB3 PD4 COL6";
$conf[6] = "COL1 PB2 PD5 COL5";
$conf[7] = "ROW8 PB1 PD6 ROW7";

for ($i=0; $i < 8; $i++) {
	@in = split(/[ \t]+/, $conf[$i]);
	$pin{"$in[0]"} = $in[1];
	$pin{"$in[3]"} = $in[2];
}

for ($i=1; $i<= 8; $i++) {
	$x = $pin{"ROW$i"};
	printf("#define\tROW$i\t$x\n");
}
print("\n");
for ($i=1; $i<= 8; $i++) {
	$x = $pin{"COL$i"};
	printf("#define\tCOL$i\t$x\n");
}
print("\n");
for ($i=1; $i<= 8; $i++) {
	$x = $pin{"ROW$i"};
	$y = substr($x,1,1);
	printf("#define\tROW$i"."_PORT\tPORT$y\n");
}
print("\n");
for ($i=1; $i<= 8; $i++) {
	$x = $pin{"ROW$i"};
	$y = substr($x,1,1);
	printf("#define\tROW$i"."_DDR\tDDR$y\n");
}
print("\n");
for ($i=1; $i<= 8; $i++) {
	$x = $pin{"COL$i"};
	$y = substr($x,1,1);
	printf("#define\tCOL$i"."_PORT\tPORT$y\n");
}
print("\n");
for ($i=1; $i<= 8; $i++) {
	$x = $pin{"COL$i"};
	$y = substr($x,1,1);
	printf("#define\tCOL$i"."_DDR\tDDR$y\n");
}
print("\n");
